﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.IO;

namespace MyMail
{
    public partial class MainForm : Form
    {
        ArrayList AttachmentFiles = new ArrayList(); //存放附件路径
        private bool IsOutSize = false; //标志附件大小是否超过1M
        public int currentIndex = 0; //记录当前发件人列表索引，修改完成过后设置选中项
        string inforpath = Application.StartupPath + "\\SenderInfor.txt";
        public MainForm()
        {
            InitializeComponent();
            GetSenderInfor();
        }

        private void btnAddSenderEmail_Click(object sender, EventArgs e) // 添加发件人
        {
            SenderInfor infor = new SenderInfor();
            if (infor.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                cmbSenderEmail.Items.Clear();
                GetSenderInfor();
            }
        }

        private void btnUpdateSenderEmail_Click(object sender, EventArgs e) // 修改发件人信息
        {
            if ((currentIndex = cmbSenderEmail.SelectedIndex) != -1)
            {
                SenderInfor infor = new SenderInfor(cmbSenderEmail.Text);
                if (infor.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    cmbSenderEmail.Items.Clear();
                    GetSenderInfor();
                    cmbSenderEmail.SelectedIndex = currentIndex;
                }
            }
            else
            {
                MessageBox.Show("请选择要修改的发件人邮箱", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.DialogResult = System.Windows.Forms.DialogResult.None;
            }
        }

        private void btnDelSenderEmail_Click(object sender, EventArgs e) //删除发件人
        {
            if (cmbSenderEmail.SelectedIndex != -1)
            {
                if (MessageBox.Show("确定删除此项吗？", "提示", MessageBoxButtons.OKCancel, MessageBoxIcon.Information) == System.Windows.Forms.DialogResult.OK)
                {
                    SenderInfor delInfor = new SenderInfor(cmbSenderEmail.SelectedItem.ToString());
                    string oldinfor = delInfor.OldInforLine;
                    string[] content;
                    string[] content1;
                    bool IsCompared = false; //标识是否经过删除项，如果是，则用content的下一项来填充content1的当前项，实现删除content的效果
                    content = File.ReadAllLines(inforpath, Encoding.Default);
                    content1 = new string[content.Length - 1];
                    for (int i = 0; i < content.Length; i++)
                    {
                        if (content[i] != oldinfor)
                        {
                            if (i == content.Length - 1)
                            {
                                break;
                            }
                            if (IsCompared)   //如果超过比较项，则用content的下一项来填充content1的当前项
                            {
                                content1[i] = content[i + 1];
                            }
                            else  //如果不是比较项，则逐项赋值
                            {
                                content1[i] = content[i];
                            }
                            continue;
                        }
                        else
                        {
                            content1[i] = content[i + 1];
                            IsCompared = true;
                        }
                    }
                    FileStream stream2 = File.Open(inforpath, FileMode.OpenOrCreate, FileAccess.Write);
                    stream2.Seek(0, SeekOrigin.Begin);
                    stream2.SetLength(0); //清空txt文件
                    stream2.Close();
                    File.WriteAllLines(inforpath, content1);

                    cmbSenderEmail.Items.Clear();
                    GetSenderInfor();
                }
            }
            else
            {
                MessageBox.Show("请选择要删除的发件人邮箱", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.DialogResult = System.Windows.Forms.DialogResult.None;
            }
        }

        /// <summary>
        /// 填充发件人列表
        /// </summary>
        private void GetSenderInfor()
        {
            using (FileStream stream = new FileStream(inforpath, FileMode.OpenOrCreate, FileAccess.Read))
            {
                using (StreamReader reader = new StreamReader(stream, Encoding.Default))
                {
                    string GetSenderInfor;
                    while ((GetSenderInfor = reader.ReadLine()) != null)
                    {
                        string[] line = GetSenderInfor.Trim().Split(' ');
                        cmbSenderEmail.Items.Add(line[1]);
                    }
                    cmbSenderEmail.SelectedIndex = 0;
                }
            }
        }

        private void btnAddEmail_Click(object sender, EventArgs e) // 添加收件人
        {
            AddEmail addemail = new AddEmail();
            if (addemail.ShowDialog() == System.Windows.Forms.DialogResult.OK && !lstEmail.Items.Contains(addemail.ReceiveEmail))
            {
                lstEmail.Items.Add(addemail.ReceiveEmail);
            }
        }

        private void btnDelEmail_Click(object sender, EventArgs e) //删除收件人
        {
            if (lstEmail.SelectedIndex != -1)
            {
                if (MessageBox.Show("确定删除此项吗？", "提示", MessageBoxButtons.OKCancel, MessageBoxIcon.Information) == System.Windows.Forms.DialogResult.OK)
                {
                    lstEmail.Items.RemoveAt(lstEmail.SelectedIndex);
                }
            }
            else
            {
                MessageBox.Show("请选择删除项", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btnInput_Click(object sender, EventArgs e) //批量导入发件人
        {
            openFileDialog1.Title = "选择文件";
            openFileDialog1.Filter = "文本文档|*.txt|全部|*.*";
            openFileDialog1.FileName = "";
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (FileStream stream = new FileStream(openFileDialog1.FileName, FileMode.Open, FileAccess.Read))
                {
                    using (StreamReader reader = new StreamReader(stream, Encoding.Default))
                    {
                        string GetSenderInfor;
                        while ((GetSenderInfor = reader.ReadLine()) != null)
                        {
                            if (!lstEmail.Items.Contains(GetSenderInfor))
                            {
                                lstEmail.Items.Add(GetSenderInfor.Trim());
                            }
                        }
                    }
                }
            }
        }

        private void linkClear_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            this.txtAttachment.Text = "";
            lblwarn.Text = "";
            AttachmentFiles.Clear();
            IsOutSize = false;
        }

        private void linkAddAttach_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) //添加附件
        {
            openFileDialog1.Title = "选择附件";
            openFileDialog1.FileName = "";
            openFileDialog1.Multiselect = true;
            openFileDialog1.Filter = "压缩文件|*.zip;*.rar;*.7z|所有文件|*.*";
            if (openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                int filesize = 0;
                string[] str = openFileDialog1.FileNames;
                foreach (string str1 in str)
                {
                    AttachmentFiles.Add(str1);
                    txtAttachment.Text += Path.GetFileName(str1) + ";";

                    FileInfo fileinfor = new FileInfo(str1);
                    filesize = filesize + Convert.ToInt32(fileinfor.Length / 1024);
                    if (filesize >= 1024)
                    {
                        lblwarn.Text = "附件总大小超过了1M";
                        IsOutSize = true;
                    }
                }
            }
        }

        private void linkHelp_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) //帮助
        {
            AboutForm aboutme = new AboutForm();
            aboutme.ShowDialog();
        }

        private void btnSingleSend_Click(object sender, EventArgs e) //单条发送
        {
            if (IsCheck())
            {
                if (lstEmail.SelectedIndex != -1)
                {
                    ThreadSendEmail threadsendemail = new ThreadSendEmail(cmbSenderEmail.Text, txtObject.Text, txtBody.Text, lstEmail.SelectedItem.ToString(), AttachmentFiles);
                    threadsendemail.Send();
                }
                else
                {
                    MessageBox.Show("请选择一项收件人", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    this.DialogResult = System.Windows.Forms.DialogResult.None;
                }
            }
        }

        private void btnAllSend_Click(object sender, EventArgs e) //全部发送
        {
            if (IsCheck())
            {
                for (int i = 0; i < lstEmail.Items.Count; i++)
                {
                    ThreadSendEmail threadsendemail = new ThreadSendEmail(cmbSenderEmail.Text, txtObject.Text, txtBody.Text, lstEmail.Items[i].ToString(), AttachmentFiles);
                    threadsendemail.Send();
                }
            }
        }

        /// <summary>
        /// 检测各项是否通过验证
        /// </summary>
        /// <returns>通过：true；没通过：false</returns>
        protected bool IsCheck()
        {
            int errCount = 0;
            if (txtObject.Text == "")
            {
                MessageBox.Show("邮件标题不能为空", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                errCount++;
                return false;
            }
            if (txtBody.Text == "")
            {
                MessageBox.Show("邮件正文不能为空", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                errCount++;
                return false;
            }
            if (IsOutSize)
            {
                MessageBox.Show("对不起，附件总大小超过了1M，禁止发送", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                errCount++;
                return false;
            }
            if (lstEmail.Items.Count == 0)
            {
                MessageBox.Show("无收件人，不能发送", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                errCount++;
                return false;
            }
            if (cmbSenderEmail.SelectedIndex == -1)
            {
                MessageBox.Show("请选择发件人邮箱", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                errCount++;
                return false;
            }
            if (errCount == 0)
            {
                return true;
            }
            else
            {
                MessageBox.Show("出错了T_T", "提示", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                return false;
            }
        }
    }
}
