﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.IO;

namespace MyMail
{
    public partial class SenderInfor : Form
    {
        #region 发件人信息
        /// <summary>
        /// SMTP服务器
        /// </summary>
        public string SMTPServer
        {
            get { return txtSMTP.Text.Trim(); }
            set { txtSMTP.Text = value; }
        }
        /// <summary>
        /// 发件人邮箱
        /// </summary>
        public string SenderEmail
        {
            get { return txtSenderEmail.Text.Trim(); }
            set { txtSenderEmail.Text = value; }
        }
        /// <summary>
        /// 发件人密码
        /// </summary>
        public string SenderPwd
        {
            get { return txtSenderPwd.Text.Trim(); }
            set { txtSenderPwd.Text = value; }
        }
        #endregion

        bool arg = false; //标识是“修改”true，还是“添加”false发件人
        public string OldInforLine = null; //就信息
        public string NewInforLine = null; //新信息
        string PathBase = Application.StartupPath;
        string inforpath = @"\SenderInfor.txt";
        public SenderInfor()
        {
            InitializeComponent();
            arg = false;
        }
        public SenderInfor(string strSenderEmail)
        {
            InitializeComponent();
            arg = true;
            txtSenderEmail.Text = strSenderEmail; //
            GetOldSenderInfor(strSenderEmail);    //根据邮箱得到SMTP、密码
            OldInforLine = txtSMTP.Text + " " + txtSenderEmail.Text + " " + txtSenderPwd.Text;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = System.Windows.Forms.DialogResult.Cancel;
        }

        private void btnReset_Click(object sender, EventArgs e)
        {
            ClearContent();
        }

        private void ClearContent()
        {
            txtSenderEmail.Text = "";
            txtSenderPwd.Text = "";
            txtSMTP.Text = "";
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            NewInforLine = txtSMTP.Text + " " + txtSenderEmail.Text + " " + txtSenderPwd.Text;
            Regex regex = new Regex(@"^\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$"); //验证Email格式
            if (regex.IsMatch(txtSenderEmail.Text.Trim()) && txtSenderPwd.Text.Trim() != "")
            {
                if (arg) //修改发件人
                {
                    string[] content;
                    string[] content1;
                    try
                    {
                        content = File.ReadAllLines(PathBase + inforpath, Encoding.Default);
                        content1 = new string[content.Length];
                        for (int i = 0; i < content.Length; i++)
                        {
                            if (content[i] != OldInforLine)
                            {
                                content1[i] = content[i];
                                continue;
                            }
                            content1[i] = NewInforLine;
                        }

                        FileStream stream2 = File.Open(inforpath, FileMode.OpenOrCreate, FileAccess.Write);
                        stream2.Seek(0, SeekOrigin.Begin);
                        stream2.SetLength(0); //清空txt文件
                        stream2.Close();
                        File.WriteAllLines(PathBase + inforpath, content1);
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
                }
                else //添加发件人
                {
                    using (FileStream stream = new FileStream(inforpath, FileMode.Append, FileAccess.Write))
                    {
                        using (StreamWriter write = new StreamWriter(stream, Encoding.Default))
                        {
                            string stremail = txtSMTP.Text + " " + txtSenderEmail.Text + " " + txtSenderPwd.Text;
                            write.WriteLine(stremail);
                        }
                    }
                }
                ClearContent();
                this.DialogResult = System.Windows.Forms.DialogResult.OK;
            }
            else
            {
                MessageBox.Show("邮箱格式不正确", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.DialogResult = System.Windows.Forms.DialogResult.None;
            }
        }

        public void GetOldSenderInfor(string NeedEmail)
        {
            using (FileStream stream = new FileStream(PathBase + inforpath, FileMode.OpenOrCreate, FileAccess.Read))
            {
                using (StreamReader read = new StreamReader(stream, Encoding.Default))
                {
                    string[] line = null;
                    string GetSenderInfor;
                    while ((GetSenderInfor = read.ReadLine()) != null)
                    {
                        line = GetSenderInfor.Trim().Split(' ');
                        if (line[1] == NeedEmail)
                        {
                            txtSMTP.Text = line[0];
                            txtSenderPwd.Text = line[2];
                        }
                    }
                }
            }
        }

        private void SenderInfor_HelpButtonClicked(object sender, CancelEventArgs e)
        {
            AboutForm aboutme = new AboutForm();
            aboutme.ShowDialog();
        }
    }
}
