﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Mail;
using System.Collections;
using System.IO;
using System.Windows.Forms;

namespace MyMail
{
    class ThreadSendEmail
    {
        string inforpath = @"\SenderInfor.txt";
        protected string strSenderEmail;
        protected string strSenderSMTP;
        protected string strSnederPwd;
        protected string strEmailTitle;
        protected string strEmailBody;
        protected string strToEmail;
        protected ArrayList arrAttachmentFiles;

        /// <summary>
        /// 发送邮件
        /// </summary>
        /// <param name="strSenderEmail">发件人邮箱</param>
        /// <param name="strTitle">邮件标题</param>
        /// <param name="strBody">邮件正文</param>
        /// <param name="ToEmail">收件人邮箱</param>
        /// <param name="AttachmentFiles">附件</param>
        public ThreadSendEmail(string strSenderEmail, string strTitle, string strBody, string ToEmail, ArrayList AttachmentFiles)
        {
            this.strSenderEmail = strSenderEmail;
            strToEmail = ToEmail;
            strEmailTitle = strTitle;
            strEmailBody = strBody;
            arrAttachmentFiles = AttachmentFiles;

            using (FileStream stream = new FileStream(inforpath, FileMode.OpenOrCreate, FileAccess.Read))
            {
                using (StreamReader read = new StreamReader(stream, Encoding.Default))
                {
                    string GetSenderInfor;
                    while ((GetSenderInfor = read.ReadLine()) != null)
                    {
                        string[] line = GetSenderInfor.Trim().Split(' ');
                        if (line[1] == strSenderEmail)
                        {
                            strSenderSMTP = line[0];
                            strSnederPwd = line[2];
                        }
                    }
                }
            }
        }

        /// <summary>
        /// 发送邮件
        /// </summary>
        /// <returns>true:发送成功 false:发送失败</returns>
        public bool Send()
        {
            SmtpClient client = new SmtpClient();
            client.Host = strSenderSMTP;
            client.UseDefaultCredentials = false;
            client.Credentials = new System.Net.NetworkCredential(strSenderEmail, strSnederPwd);
            client.DeliveryMethod = SmtpDeliveryMethod.Network;

            MailMessage mm = new MailMessage(strSenderEmail, strToEmail, strEmailTitle, strEmailBody);
            mm.BodyEncoding = Encoding.Default;
            mm.IsBodyHtml = true;

            if (arrAttachmentFiles.Count != 0)
            {
                foreach (string attach in arrAttachmentFiles)
                {
                    Attachment attachment = new Attachment(attach, System.Net.Mime.MediaTypeNames.Application.Octet);
                    mm.Attachments.Add(attachment);
                }
            }

            try
            {
                client.Send(mm);
                MessageBox.Show("邮件发送成功", "成功", MessageBoxButtons.OK);
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show("发送失败" + ex.Message, "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return false;
            }
        }
    }
}
